#ifndef LEDDELEGATE_H
#define LEDDELEGATE_H

#include <QStyledItemDelegate>

class DelegateIndexSelector;

class LedDelegate : public QStyledItemDelegate {
    Q_OBJECT
public:
    static const int Color1Role = Qt::UserRole + 1;
    static const int Color2Role = Qt::UserRole + 2;


    LedDelegate(QObject *parent = Q_NULLPTR, DelegateIndexSelector *paintSelector = Q_NULLPTR);
    ~LedDelegate() override;

    void paint(QPainter *painter, const QStyleOptionViewItem &option, const QModelIndex &index) const override;

    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const override {
        Q_UNUSED(parent)
        Q_UNUSED(option)
        Q_UNUSED(index)
        return Q_NULLPTR;
    }

protected:
    bool paintEnabled(const QModelIndex &index) const;
    void paintLed(QPainter *painter, const QStyleOptionViewItem &option, const QRect &rect, const QModelIndex &index) const;
private:
    DelegateIndexSelector *m_paintSelector;
};

#endif // LEDDELEGATE_H
