#ifndef DEVINDIGCONFIG_H
#define DEVINDIGCONFIG_H

#include "lqmeas/devs/DeviceConfigIface.h"


namespace LQMeas {
    class DevInDigInfo;

    class DevInDigConfig : public DeviceConfigIface {
        Q_OBJECT
    public:
        DevInDigConfig(const DevInDigInfo &devinfo);
        DevInDigConfig(const DevInDigConfig &cfg);
        const DevInDigInfo *inDigInfo() const {return m_in_dig_info;}

        virtual bool inDigChAvailable(int ch) const;
    protected:
        QString cfgIfaceName() const override {return  QStringLiteral("InDig");}
        void inDigUpdateDevInfo(const DeviceTypeInfo *devinfo);
    private:
        const DevInDigInfo *m_in_dig_info;

        friend class DeviceConfig;
    };
}

#endif // DEVINDIGCONFIG_H
